// InputEventDemo.java
// program to demonstrate mouse and keyboard events

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

class Gui extends JFrame implements WindowListener, MouseListener, KeyListener
{
  boolean shiftDown=false,altDown=false,controlDown=false;

	// constructor
	public Gui(String s)
	{
		super(s);
		getContentPane().setBackground(Color.yellow);
		addMouseListener(this);
		addWindowListener(this);
                addKeyListener(this);
	}

  // Implement KeyListener methods
      /**
     * Invoked when a key has been typed.
     * This event occurs when a key press is followed by a key release.
     */
    public void keyTyped(KeyEvent e)
    {
    }
    /**
     * Invoked when a key has been pressed.
     */
    public void keyPressed(KeyEvent e)
    {if (!shiftDown && !controlDown && !altDown)
        System.out.print("Key Pressed:");
     if (e.isShiftDown() && !shiftDown) {
        System.out.print("Shift ");
        shiftDown=true;
     }
     else if (e.isAltDown() && !altDown){
        System.out.print("Alt ");
        altDown=true;
     }
     else if (e.isControlDown() && !controlDown) {
        System.out.print("Control ");
        controlDown=true;
     }
     else if (e.isActionKey())
         System.out.println(" "+KeyEvent.getKeyText(e.getKeyCode()));
     else
         System.out.println(" "+e.getKeyChar());
    }
    /**
     * Invoked when a key has been released.
     */
    public void keyReleased(KeyEvent e)
    {// Need to determine which keys were released
     if (shiftDown && !e.isShiftDown())
        shiftDown=false;
     if (altDown && !e.isAltDown())
        altDown=false;
     if (controlDown && !e.isControlDown())
        controlDown=false;
    }

  // Implement MouseListener methods
	public void mouseClicked(MouseEvent event)
	{// If there was more than one click....
		if (event.getClickCount()>1) {
			Point p=event.getPoint();
			System.out.println(event.getClickCount()+
              " Clicks Occured at ("+event.getX()+","+event.getY()+") ");
		}

/*                // this switch didn't compile in JBuilder; it should?
                  switch (event.getModifiers()){
                       case event.BUTTON1_MASK:
                            System.out.println("Left Button Pressed");break;
                       case event.BUTTON2_MASK:
                            System.out.println("Middle Button Pressed");break;
                       case event.BUTTON3_MASK:
                            System.out.println("Right Button Pressed");break;
                }
*/
                if (event.getModifiers()==event.BUTTON1_MASK)
                            System.out.println("Left Button Pressed");
                else if (event.getModifiers()==event.BUTTON2_MASK)
                            System.out.println("Middle Button Pressed");
                else if (event.getModifiers()==event.BUTTON3_MASK)
                            System.out.println("Right Button Pressed");

	}

	public void mouseEntered(MouseEvent event)
	{	System.out.println("Entry Occured at ("+event.getX()+","
                                                     +event.getY()+")");
	}
	public void mouseExited(MouseEvent event)
  {System.out.println("Exit Occured at ("+event.getX()+","
                                                     +event.getY()+")");
	}
	public void mouseReleased(MouseEvent event){}

	public void mousePressed(MouseEvent event)
	{	if (event.getClickCount()==1) {
			// get coordinates of mouse
			int x = event.getX();
			int y = event.getY();

			// display message on screen
			System.out.println("+ ["+String.valueOf(x)+","+String.valueOf(y)+"]");
		}
	}

	public void windowClosed(WindowEvent event){}
	public void windowDeiconified(WindowEvent event){}

	public void windowIconified(WindowEvent event)
  {System.out.println("Window has been Iconified");}

	public void windowActivated(WindowEvent event){}
	public void windowDeactivated(WindowEvent event){}
	public void windowOpened(WindowEvent event){}

	public void windowClosing(WindowEvent event)
	{
		System.exit(0);
	}
}

class InputEventDemo
{
	public static void main(String[] args)
	{
		Gui screen = new Gui("InputEventDemo");

		screen.setSize(400,300);
		screen.setVisible(true);
	}
}
